divert(-1)
define(haskell_compiler, ghc)
define(haskell_with_ffi_th_compiler, ghc -fffi -fglasgow-exts -package lang -package haskell-src)

define(haskell_modules_program,haskell_modules($1, $2)
haskell_program($1, $2, $3))

# Takes a path, compiler line
define(haskell_modules,
include $1/dependencies

$1/%.o: $1/%.lhs makefile
	$2 -c $< -i$1

$1/%.hi: $1/%.o makefile
	@:

$1/%.o $1/%.hi: $1/%.hs makefile
	$2 --make $< -i$1
	touch -r $1/$``''*.o $1/$``''*.hi

clean::
	rm -f $(patsubst %.lhs,%.o,$(wildcard $1/*.lhs))
	rm -f $(patsubst %.lhs,%.hi,$(wildcard $1/*.lhs))
)

# Takes a path, compiler line, program name
define(haskell_program,
$1/$3: $(wildcard $1/*.o) $(patsubst %.lhs,%.o,$(wildcard $1/*.lhs)) makefile
	$2 -o $``''@ $1/*.o

$1/$3.o $1/$3.hi $1/Main.hi: $1/$3.lhs makefile
	$2 -c $< -i$1
	ln -sf Main.hi $1/$3.hi
	touch -r $1/$3.hi $1/$3.lhs

clean::
	rm -f $1/$3 $1/Main.hi
)
divert
